/*******************************************************************************
 * Copyright 2019, 2020 grondag
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License.  You may obtain a copy
 * of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations under
 * the License.
 ******************************************************************************/
package grondag.fluidity.impl.article;

import static org.apiguardian.api.API.Status.INTERNAL;

import java.util.function.Consumer;
import net.minecraft.class_2348;
import net.minecraft.class_2378;
import net.minecraft.class_2385;
import net.minecraft.class_2960;
import net.minecraft.class_5321;
import com.mojang.serialization.Lifecycle;
import org.apiguardian.api.API;
import grondag.fluidity.api.article.ArticleType;
import grondag.fluidity.api.article.ArticleTypeRegistry;

@SuppressWarnings({ "unchecked", "rawtypes" })
@API(status = INTERNAL)
public final class ArticleTypeRegistryImpl implements ArticleTypeRegistry {
	private ArticleTypeRegistryImpl() {

	}

	public static void init() {}

	public static ArticleTypeRegistryImpl INSTANCE = new ArticleTypeRegistryImpl();

	private static final class_5321 REGISTRY_KEY = class_5321.method_29180(new class_2960("fluidity:article_types"));
	private static final class_2385<ArticleTypeImpl> ARTICLE_REGISTRY;

	static {
		ARTICLE_REGISTRY = (class_2385<ArticleTypeImpl>) ((class_2385) class_2378.field_11144).method_10272(REGISTRY_KEY,
				new class_2348("fluidity:nothing", REGISTRY_KEY, Lifecycle.stable()), Lifecycle.stable());
	}

	@Override
	public <T> class_2960 getId(ArticleType<T> article) {
		return ARTICLE_REGISTRY.method_10221((ArticleTypeImpl) article);
	}

	@Override
	public int getRawId(ArticleType article) {
		return ARTICLE_REGISTRY.method_10206((ArticleTypeImpl) article);
	}

	@Override
	public ArticleTypeImpl get(class_2960 id) {
		return ARTICLE_REGISTRY.method_10223(id);
	}

	@Override
	public ArticleTypeImpl get(String idString) {
		return ARTICLE_REGISTRY.method_10223(new class_2960(idString));
	}

	@Override
	public ArticleTypeImpl get(int index) {
		return ARTICLE_REGISTRY.method_10200(index);
	}

	@Override
	public void forEach(Consumer<? super ArticleType<?>> consumer) {
		ARTICLE_REGISTRY.forEach((Consumer<? super ArticleType>) consumer);
	}

	@Override
	public ArticleType add(class_2960 id, ArticleType articleType) {
		return ARTICLE_REGISTRY.method_10272(class_5321.method_29179(REGISTRY_KEY, id), (ArticleTypeImpl) articleType, Lifecycle.stable());
	}

	@Override
	public boolean contains(class_2960 id) {
		return ARTICLE_REGISTRY.method_10235().contains(id);
	}
}
