/*******************************************************************************
 * Copyright 2019, 2020 grondag
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License.  You may obtain a copy
 * of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations under
 * the License.
 ******************************************************************************/
package grondag.fluidity.impl.article;

import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_2487;
import org.apiguardian.api.API;
import org.apiguardian.api.API.Status;

@API(status = Status.INTERNAL)
public class StackHelper {
	public static class_1799 newStack(class_1792 item, class_2487 tag, long count) {
		if (item == null || item == class_1802.field_8162 || count <= 0) {
			return class_1799.field_8037;
		}

		final class_1799 result = new class_1799(item, (int) Math.min(item.method_7882(), count));
		result.method_7980(tag);
		return result;
	}

	public static boolean areItemsEqual(class_1792 itemA, class_2487 tagA, class_1792 itemB, class_2487 tagB) {
		if (itemA != itemB) {
			return false;
		}

		if (tagA == null) {
			return tagB == null;
		}

		return tagB != null && tagA.equals(tagB);
	}

	public static boolean areItemsEqual(class_1792 item, class_2487 tag, class_1799 stack) {
		if (item != stack.method_7909()) {
			return false;
		}

		if (tag == null) {
			return !stack.method_7985();
		}

		return stack.method_7985() && tag.equals(stack.method_7969());
	}

	public static boolean areItemsEqual(class_1799 a, class_1799 b) {
		return areItemsEqual(a.method_7909(), a.method_7969(), b);
	}

	public static boolean areStacksEqual(class_1799 stackA, class_1799 stackB)  {
		if (stackA.method_7960() && stackB.method_7960()) {
			return true;
		}

		if (stackA.method_7929(stackB) && stackA.method_7947() == stackB.method_7947()) {
			return true;
		}

		return false;
	}
}
